var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name3 in all)
    __defProp(target, name3, { get: all[name3], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/qa/src/index.ts
var src_exports = {};
__export(src_exports, {
  install: () => install3,
  name: () => name2,
  using: () => using2
});
module.exports = __toCommonJS(src_exports);
var import_plugin_database = require("@zhinjs/plugin-database");

// packages/qa/src/models/question.ts
var import_sequelize = require("sequelize");
var QA = {
  question: import_sequelize.DataTypes.TEXT,
  answer: import_sequelize.DataTypes.TEXT,
  isReg: import_sequelize.DataTypes.BOOLEAN,
  probability: {
    type: import_sequelize.DataTypes.FLOAT,
    defaultValue: 1
  },
  redirect: import_sequelize.DataTypes.TEXT,
  belongs: {
    type: import_sequelize.DataTypes.TEXT,
    get() {
      const str = this.getDataValue("belongs") || "";
      if (!str)
        return [];
      return str.split(",").map((str2) => {
        const [type, target] = str2.split(":");
        return { type, target };
      });
    },
    set(data) {
      const belongs = data.map((item) => `${item.type}:${item.target}`).join(",");
      this.setDataValue("belongs", belongs);
    }
  }
};

// packages/qa/src/teach.ts
var teach_exports = {};
__export(teach_exports, {
  DialogueCnMap: () => DialogueCnMap,
  install: () => install,
  using: () => using
});
var import_zhin = require("zhin");
var import_sequelize2 = require("sequelize");
var DialogueCnMap = {
  id: "ID",
  answer: "回答",
  isReg: "是否正则",
  question: "问题",
  probability: "触发概率权重(相同问题多个回答时，计算触发概率)",
  belongs: "触发条件",
  redirect: "重定向到",
  group: "群",
  private: "好友",
  discuss: "讨论组"
};
function transformDialogueValue(key, value) {
  if (key === "belongs") {
    if (!value.length)
      return "所有消息均可触发";
    return value.map((item) => `触发方式:${transformDialogueKey(item.type)}消息,指定${transformDialogueKey(item.type)}:${item.target}`).join("\n");
  }
  return value;
}
__name(transformDialogueValue, "transformDialogueValue");
function transformDialogueKey(key) {
  return DialogueCnMap[key] || key;
}
__name(transformDialogueKey, "transformDialogueKey");
function transformDialogue(dialogue) {
  return Object.keys(dialogue).map((key) => {
    return `${transformDialogueKey(key)}:${transformDialogueValue(key, dialogue[key])}`;
  }).join("\n");
}
__name(transformDialogue, "transformDialogue");
import_zhin.template.set("teach", {
  "list": `已有问答如下:
{0}
{1}`,
  "detail": `问答({0})的详情:
{1}`,
  "add": `问答({0})已添加`,
  "edit": `问答({0})已更新`,
  "remove": `问答({0})已删除`,
  "pagination": "第{0}/{1}页，共{2}条",
  "search": `关键词({0})的搜索结果:
{1}
{2}`,
  "404": `{0}({1})未找到任何有关问答`
});
var using = ["database"];
function install(ctx) {
  ctx.command("qa [question:string] [answer]").desc("问答管理").option("list", "-l 查看问答列表").option("info", "-i <id:string> 查看指定教学详情").option("search", "-s <keyword:string> 搜索关键词").option("delete", "-d <id:string> 删除指定id的教学").option("regexp", "-x 是否为正则匹配").option("redirect", "-> <question:string> 重定向到指定问题").option("probability", "-p <probability:number> 触发概率").option("trigger", "-t [trigger:string] 触发环境").option("page", "/ <page:integer> 页码").shortcut(/^## (\S+)$/, { options: { search: "$1" }, fuzzy: true }).option("edit", "-e 是否为编辑").shortcut(/^删除问答(\d+)$/, { options: { id: "$1", remove: true } }).shortcut(/^查看问答(\d+)$/, { options: { id: "$1", detail: true } }).example("`# -l` 查看第一页").example("`# -l / 2` 查看第二页问答").example("`# -s test` 搜索关键词为`test`的问答").example("`# test hello -p 0.5` 当输入`test`时，回复`hello`，并设置该会带的概率权重为0.5").example("`# test world` 将test的回答改为`world`").action(async ({ session, options }, q, a) => {
    if (Object.keys(options).filter((key) => ["list", "detail", "search", "edit", "remove"].includes(key)).length > 1) {
      return "查询/列表/详情、编辑/删除只能同时调用一个";
    }
    function filterResult(list) {
      const result = list.map((teach) => teach.toJSON()).filter((dialogue) => {
        let trigger = options.trigger;
        if (trigger === void 0) {
          trigger = `${session.detail_type}:${session["group_id"] || session["discuss_id"] || session.user_id}`;
        }
        const tmpArr = trigger.split(",").map((str) => {
          const [t1, t2] = str.split(":");
          return {
            type: t1,
            target: t2 ? t2 : "*"
          };
        }).filter((tmp) => !!tmp.type);
        return dialogue.belongs.length === 0 || dialogue.belongs.some((belong) => {
          return tmpArr.some((tmp) => tmp.type === belong.type && (belong.target === "*" || belong.target.includes(tmp.target)));
        });
      }).map((dialogue, idx) => `${idx + 1}. ID:${dialogue.id} 问题:${dialogue.question} 回答:${dialogue.answer} 是否正则:${dialogue.isReg ? "是" : "否"}${dialogue.redirect ? ` 重定向到:${dialogue.redirect}` : ""}`);
      return {
        rows: result.filter((_, index) => index >= ((options.page || 1) - 1) * 15 && index < (options.page || 1) * 15),
        count: result.length
      };
    }
    __name(filterResult, "filterResult");
    if (options.search) {
      const condition = {
        where: {
          [import_sequelize2.Op.or]: {
            question: { [import_sequelize2.Op.like]: `%${options.search}%` },
            answer: { [import_sequelize2.Op.like]: `%${options.search}%` }
          }
        },
        sort: [["createdAt", "DESC"]]
      };
      if (options.page) {
        if (!Number.isInteger(options.page) || options.page < 1)
          return "页码只能为正整数";
      }
      const data = await ctx.database.models.QA.findAll(condition);
      const { rows, count } = filterResult(data);
      return (0, import_zhin.h)("text", { text: (0, import_zhin.template)("teach.search", options.search, rows.join("\n"), (0, import_zhin.template)("teach.pagination", options.page || 1, Math.ceil(count / 15), count)) });
    }
    if (options.list) {
      const condition = {
        where: {},
        sort: [["createdAt", "DESC"]]
      };
      if (options.page) {
        if (!Number.isInteger(options.page) || options.page < 1)
          return "页码只能为正整数";
      }
      const data = await ctx.database.models.QA.findAll(condition);
      const { rows, count } = filterResult(data);
      return (0, import_zhin.h)("text", { text: (0, import_zhin.template)("teach.list", rows.join("\n"), (0, import_zhin.template)("teach.pagination", options.page || 1, Math.ceil(count / 15), count)) });
    }
    if (options.info) {
      const teach = await ctx.database.models.QA.findOne({
        attributes: ["id", "question", "answer", "isReg", "redirect", "probability", "belongs"],
        where: {
          id: options.info
        }
      });
      if (!teach) {
        return (0, import_zhin.template)("teach.404", "ID", options.info);
      }
      const dialogue = teach.toJSON();
      return (0, import_zhin.h)("text", { text: (0, import_zhin.template)("teach.detail", options.info, transformDialogue(dialogue)) });
    }
    if (options.delete) {
      const dialogue = await ctx.database.models.QA.destroy({
        where: {
          id: options.delete
        }
      });
      if (dialogue) {
        return (0, import_zhin.template)("teach.remove", options.delete);
      }
    }
    if (q) {
      const data = {
        isReg: !!options.regexp
      };
      if (a) {
        data.answer = a.join("");
      }
      if (options.probability) {
        data.probability = options.probability;
      }
      if (options.trigger !== void 0) {
        data.belongs = options.trigger.split(",").map((trigger) => {
          const [type, target] = trigger.split(":");
          return {
            type,
            target: target ? target : "*"
          };
        }).filter((belong) => !!belong.type);
      }
      if (options.redirect) {
        data.redirect = options.redirect;
      }
      let dialogues = await ctx.database.models.QA.findAll({
        where: {
          question: q
        }
      });
      let [dialogue] = dialogues;
      if (options.edit) {
        if (dialogues.length > 1) {
          await session.reply((0, import_zhin.template)("teach.list", filterResult(dialogues).rows.join("\n"), "请输入要编辑的问答索引"));
          const index = await session.prompt.select("请选择要编辑的问答", {
            child_type: "number",
            options: filterResult(dialogues).rows.map((item, i) => ({ title: item, value: i }))
          });
          if (typeof index !== "number")
            return "输入超时";
          if (index < 1 || index > dialogues.length) {
            await session.reply("输入错误");
            return;
          }
          dialogue = dialogues[index - 1];
        }
        if (!dialogue) {
          return (0, import_zhin.template)("teach.404", "问题", q);
        }
        await dialogue.update(data);
        return (0, import_zhin.template)("teach.edit", dialogue.get("id"));
      }
      if (dialogue && dialogue.get("answer") === a) {
        const confirm = await session.prompt.confirm("已存在相同问答，是否继续添加？");
        if (!confirm)
          return "已取消添加";
      }
      dialogue = await ctx.database.models.QA.create({
        ...data,
        question: q
      });
      return (0, import_zhin.template)("teach.add", dialogue.get("id"));
    }
  });
}
__name(install, "install");

// packages/qa/src/receiver.ts
var receiver_exports = {};
__export(receiver_exports, {
  install: () => install2,
  name: () => name,
  triggerTeach: () => triggerTeach
});
var import_zhin2 = require("zhin");
function hasEnv(envs, type, target) {
  return envs.length === 0 || envs.some((item) => {
    return item.type === type && (item.target === "*" || item.target.includes(String(target)));
  });
}
__name(hasEnv, "hasEnv");
async function triggerTeach(ctx, session) {
  const teaches = await ctx.database.models.QA.findAll();
  const question = session.elements.join("");
  const dialogues = teaches.map((teach) => teach.toJSON()).filter((teach) => hasEnv(teach.belongs, session.detail_type, session.group_id || session.discuss_id || session.user_id)).filter((teach) => {
    return teach.isReg ? new RegExp(teach.question).test(question) : question === teach.question;
  });
  const totalProbability = dialogues.reduce((p, dialogue2) => {
    p += dialogue2.probability;
    return p;
  }, 0);
  function fixProbability(probability) {
    let baseProbability = 0;
    dialogues.forEach((dialogue2) => {
      dialogue2.activeArea = [baseProbability, dialogue2.probability / (totalProbability < 0 ? 1 : totalProbability) + baseProbability];
      baseProbability += dialogue2.probability / (totalProbability < 0 ? 1 : totalProbability);
      dialogue2["active"] = probability > dialogue2.activeArea[0] && probability <= dialogue2.activeArea[1];
    });
  }
  __name(fixProbability, "fixProbability");
  fixProbability(Math.random());
  if (!dialogues.length)
    return;
  const [dialogue] = dialogues.filter((d) => d.active);
  if (!dialogue)
    return;
  if (dialogue.redirect) {
    if (dialogue.isReg) {
      const args = new RegExp(dialogue.question).exec(question);
      let index = 0;
      while (index < args.length - 1) {
        index++;
        const reg = new RegExp("\\$" + index, "gm");
        dialogue.redirect = dialogue.redirect.replace(reg, args[index]);
      }
    }
    session.elements = import_zhin2.Element.parse(dialogue.redirect, session);
    return triggerTeach(ctx, session);
  }
  if (dialogue.isReg) {
    const args = new RegExp(dialogue.question).exec(question);
    let index = 0;
    while (index < args.length - 1) {
      index++;
      const reg = new RegExp("\\$" + index, "gm");
      dialogue.answer = dialogue == null ? void 0 : dialogue.answer.replace(reg, args[index]);
    }
  }
  let answerText = dialogue.answer.replace(/\$0/g, question);
  try {
    return await session.render(import_zhin2.Element.parse(answerText, session));
  } catch {
    return answerText;
  }
}
__name(triggerTeach, "triggerTeach");
var name = "qa.receiver";
function install2(ctx) {
  let preMessageId = "";
  ctx.zhin.middleware(async (session, next) => {
    await next();
    if (preMessageId === session.message_id)
      return;
    preMessageId = session.message_id;
    if (session.type === "message") {
      const result = await triggerTeach(ctx, session).catch(() => {
      });
      if (result)
        session.reply(result);
    }
  }, true);
}
__name(install2, "install");

// packages/qa/src/index.ts
var name2 = "qa";
var using2 = ["database"];
function install3(ctx) {
  if (ctx.database) {
    ctx.database.define("QA", QA);
  }
  ctx.disposes.push(
    ctx.zhin.on("database-created", () => {
      ctx.database.define("QA", QA);
    })
  );
  ctx.plugin(teach_exports);
  ctx.plugin(receiver_exports);
}
__name(install3, "install");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  install,
  name,
  using
});
//# sourceMappingURL=index.js.map
